//DotMatrix library  library
#include "LedControl.h"

 //(din,clk,cs load,number of displays)
LedControl lc=LedControl(10,12,11,1);


//array to save the data when button is pressed
int pulseArrayLeft[64];
int pulseArrayRight[64];
int halfBeats = 0;//tune into these to get half beats when required
int halfBeatCount = 0;
int QuarterBeat = 0;//tune in for quarter beat timer for displays
 int Quartercount = 0;
 int displaydelay = 0;//display delay timer
  

unsigned int RowProgress =0; //progress down display
unsigned int ColProgress =0; //progress down display

int stepA0 = analogRead(A0); 
int tempoA2 = analogRead(A2); 
int OtherStepA1 = analogRead(A1); 
 
//BUTTONS NEXT WHEN NEEDED
int EraseRecD2 = digitalRead(2); //the six switches D2-D7
int leftOutD4 = digitalRead(4);//SWITCHES TO SEND L OR R CHANNEL TO LEFT SOCKET
int rightOutD7 = digitalRead(7);//SWITCHES TO SEND L/R/ CHANNEL TO RIGHT SOCKET
int leftRightD5 = digitalRead(5);//CHOOSE REC/ERASE CHANNEL
int readD3 = digitalRead(3);
int readD6 = digitalRead(6);

int playPauseD8 = digitalRead(8);//red play rec button (doubling as morse)
int writeplayD9 = digitalRead(9);

int morseA4 = digitalRead(A4);//morse key
///PINS
char outPinA5 = A5;//A5 is the right out /bottom socket
char outPinA3 = A3;//A3 is the left out /top socket


////

// Generally, you should use "unsigned long" for variables that hold time
// The value will quickly become too large for an int to store
unsigned long previousMillis = 0;        // will store last time snakeDelay was updated

unsigned long previousMillis2 = 0;      

int pulseOn = 1;//creates pulses from the timer
int latch = 0; // a debouncer basically
//wait a gap while turning light off
int pulseOnX4 = 0;

int scanCol = 0;// 0-7 counter for matrix
int scanRow = 0; //counter for 2nd digit 8,16,24,32,40,48,56,64.
int decimalCount =0; //single counter attempt to replace the two above
int stepA0DEC =0; //used for above decimalCount

///for the 2nd channel
int scanCol2 = 0;// 0-7 counter for matrix
int scanRow2 = 0; //counter for 2nd digit 8,16,24,32,40,48,56,64.
int decimalCount2 =0; //single counter attempt to replace the two above

int stepA0DEC2 =0; //used for above decimalCount



void setup() {
  pinMode(A4, INPUT);//MORSE KEY (was a7
  pinMode(outPinA5, OUTPUT);//right
  pinMode(outPinA3, OUTPUT);//left
  // put your setup code here, to run once:
  // initialize serial communication:
Serial.begin(9600);
  
  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,7);
  /* and clear the display */
  lc.clearDisplay(0);
}/////////////////END SETUP


////////FUNCTIONS
void DotMatrixNumber(int reading) {
//the new numbers
unsigned char numbers[10][8] = {
{  B00011100,  B00100010,  B00100010,  B00100010,  B00100010,  B00100010,  B00100010,  B00011100}, //0
{  B00001000, B00011000,  B00001000,  B00001000,  B00001000,  B00001000,  B00001000,  B00011100},//1
  {  B00011100,  B00100010,  B00000010,  B00000010,  B00000100,  B00001000,  B00010000,  B00111110},//2
  {  B00011100,  B00100010,  B00000010,  B00001100,  B00000010,  B00000010,  B00100010,  B00011100},//3
  {  B00000010,  B00000110,  B00001010,  B00010010,  B00100010,  B00111110,  B00000010,  B00000010},//4
  {  B00111110,  B00100000,  B00100000,  B00111100,  B00000010,  B00000010,  B00100010,  B00011100},//5
  {  B00011100,  B00100010,  B00100000,  B00111100,  B00100010,  B00100010,  B00100010,  B00011100},//6
  {  B00111110,  B00000010,  B00000010,  B00000100,  B00001000,  B00010000,  B00010000,  B00010000},//7
{  B00011100,  B00100010,  B00100010,  B00011100,  B00100010,  B00100010,  B00100010,  B00011100},//8
{  B00011100,  B00100010,  B00100010,  B00100010,  B00011110,  B00000010,  B00100010,  B00011100}//9
};
 //this loop writes the int reading number
  for(int i=0;i<8;i++)
   { lc.setRow(0,i,numbers[reading][i]);
   }
}//end number display


//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

void dotdisplay(){
//next for the scan dot
byte a[8]={B10000000,B01000000,B00100000,B00010000,B00001000,B00000100,B00000010,B00000001};
//int columnee = 0;
//decimalCount
    lc.setRow(0,scanCol,a[scanRow]);
   lc.setRow(0,scanRow2,a[scanCol2]);
}

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
///////////////////
void ReadSensors(){
 stepA0 = analogRead(A0); 
 tempoA2 = analogRead(A2); 
 OtherStepA1 = analogRead(A1); 
 
//BUTTONS NEXT WHEN NEEDED
 EraseRecD2 = digitalRead(2); //the six switches D2-D7
 leftOutD4 = digitalRead(4);
 rightOutD7 = digitalRead(7);
 leftRightD5 = digitalRead(5);
 readD3 = digitalRead(3);
 readD6 = digitalRead(6);

playPauseD8 = digitalRead(8);
writeplayD9 = digitalRead(9);
morseA4 = digitalRead(A4);

//MAPPING for sensors
tempoA2 = map(tempoA2,1023, 0, 2000, 20);//tempo

stepA0 = map(stepA0,1023, 50, 1, 8);//step
 int tempDecMap = analogRead(stepA0); 
stepA0DEC = map(tempDecMap,1023, 50, 0, 64);//step
stepA0DEC = constrain(stepA0DEC, 0, 64);

OtherStepA1 = map(OtherStepA1,1023, 50, 1, 8);//2nd step
int tempDecMap2 = analogRead(OtherStepA1); 
stepA0DEC2 = map(tempDecMap2,1023, 50, 0, 64);//step
stepA0DEC2 = constrain(stepA0DEC2, 0, 64);


}//end read sensors


//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

//TIMER THAT SETS THE TEMPO
void tempoPulse(int period){
  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= period) {
    // save the last time pulseOn was 1
    previousMillis = currentMillis;
   
   // if the pulse is 0 (off) turn it to 1 (on) and vice-versa:
    if (pulseOn == 0) {
      pulseOn = 1;
    } else {
     //SETS THE PULSE ON FOR DISCOVERY ELSEWHERE 
      pulseOn = 0;
    }  
  }
}//>END TIMER tempoPulse

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

//4x faster TIMER THAT records variables in timing speed
void tempoPulseX4(int period){
  unsigned long currentMillis2 = millis();

  if (currentMillis2 - previousMillis2 >= (period/4)) {
    // save the last time pulseOn was 1
    previousMillis2 = currentMillis2;
   
   // if the pulse is 0 (off) turn it to 1 (on) and vice-versa:
    if (pulseOnX4 == 0) {
      pulseOnX4 = 1;
    } else {
     //SETS THE PULSE ON X4 speed FOR DISCOVERY ELSEWHERE 
      pulseOnX4 = 0;
    }  
  }
}//>END TIMER tempoPulse
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

void playNote(){

//left channel playback
  if(pulseArrayLeft[decimalCount] == 1)
  {
    //either send left channel signal to left ( leftOutD4 ==0) or right output socket
    if( leftOutD4 ==1){digitalWrite(outPinA3, HIGH);}
    if( leftOutD4 ==0){digitalWrite(outPinA3, LOW);}
  }
  
  //LEFT GAPS
  if(pulseArrayLeft[decimalCount] == 0){digitalWrite(outPinA3, LOW);}

    
    //right channel play back
    if(pulseArrayRight[decimalCount2] == 1)
  {
     //either send left channel signal to left ( leftOutD4 ==0) or right output socket
    if(rightOutD7 ==1){digitalWrite(outPinA5, HIGH);}
    if(rightOutD7 ==0){digitalWrite(outPinA5, LOW);}
  }
  
  
  //now for the RIGHT gaps or 0 pulses
  if(pulseArrayRight[decimalCount2] == 0){digitalWrite(outPinA5, LOW);}


}

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void loop() {
int stepChanged = stepA0;
int modeChanged = OtherStepA1;
ReadSensors();
tempoPulse(tempoA2);



//CHANGE DISPLAY MODES
if(writeplayD9 == 1){
  dotdisplay();
// lc.setRow(0,scanCol,a[scanRow]);
}
//test for recording duration of morse key (using red key for now)
//then record to either left or right array depending on switch D2 or D5

if(EraseRecD2 == 1){
playPauseD8 = digitalRead(8);
morseA4 = digitalRead(A4);
//IF THE SWITCH IS ON -RECORD EITHER LFT OR RIGHT TRACK DEPENDING ON SWITCH LeftRightD5
if(playPauseD8 == 1){
 //record left array
if(leftRightD5 == 0){
pulseArrayLeft[decimalCount] = 1;}
//record right array
if(leftRightD5 == 1){
pulseArrayRight[decimalCount] = 1;}
}}



//to erase notes note flick switch up and eliminate notes one by one
if(EraseRecD2 == 0){
playPauseD8 = digitalRead(8);
morseA4 = digitalRead(A4);
if(playPauseD8 == 1){
 //record left array
if(leftRightD5 == 0){
pulseArrayLeft[decimalCount] = 0;}
//record right array
if(leftRightD5 == 1){
pulseArrayRight[decimalCount] = 0;}
}}
//END space / record MODE



/////////////
//see if step setting has changed-just for display
//if it has we will delay the clear display for a quarter or 4 pulseon beats

if(stepChanged != stepA0)
{//call the numbers up to show step setting
  DotMatrixNumber(stepA0);
  //displaydelay = 1;
 // QuarterBeat =0;
}
 
if(modeChanged != OtherStepA1)
{//call the numbers up to show mode setting
  DotMatrixNumber(OtherStepA1);
    //displaydelay = 1;
    //QuarterBeat = 0;
 }

//activate the display clear delay 
//if(displaydelay == 1 and QuarterBeat == 1){
//displaydelay = 0;
//lc.clearDisplay(0); 
  // QuarterBeat = 0;
//}

//clear the display between dot scans
if(pulseOn == 0 and latch == 1){
  lc.clearDisplay(0);
    latch = 0;}

//cpulse off latch
if(pulseOn == 0 and latch == 1){
    lc.clearDisplay(0);
latch = 0;
 }

 // START THE MAIN PULSE LOOP
if(pulseOn == 1 and latch == 0){
//count the pulses 1-4

   //display delay timer
  // QuarterBeat++;
   
//if the D9 switch is on - CHANGE DISPLAY MODES
if(writeplayD9 == 0 and halfBeats == 1){
DotMatrixNumber(OtherStepA1);

}

if(writeplayD9 == 0 and halfBeats == 0){
//
DotMatrixNumber(stepA0);
}


// create halfas fast halfBeats on the halfbeat int string = 0 or 1

 if(halfBeatCount == 1){
 halfBeatCount = 0;}
  
if(halfBeats == 1){ 
  halfBeatCount = 1;
   halfBeats = 0;}
  
if(halfBeatCount == 0){ 
 halfBeats = 1 ;}
///////////

 //create quarter beats


if(halfBeats == 1){ 
  Quartercount++;
  QuarterBeat = 0;}
  
if(Quartercount == 4){
 QuarterBeat = 1;
 Quartercount = 0;}
  


// plays note each time button remembers a pulse
playNote();

latch = 1;//stop multiple click-debouncer
//advance the scan position for the dotmatrix 8x8 display
scanCol++;
scanCol2++;
//set the decimalCount going for array management - need to translate this into scanning the matrix
//rather than use the scanCol and scanRow ints 
decimalCount++;
decimalCount2++;

//first switch to quantise the count 4,9,16,25,36,49,64
//limit deciminalCount
stepA0DEC = stepA0 * stepA0;//}
stepA0DEC2 = OtherStepA1 * OtherStepA1;//}

if(decimalCount >= stepA0DEC){decimalCount =0;}
if(decimalCount2 >= stepA0DEC2){decimalCount2 =0;}



//Serial.print("\t halfBeats = ");
Serial.print("\t");
Serial.print(halfBeats);
//Serial.print("\t decimalCount2 = ");

Serial.print("\t QuarterBeat");
Serial.print(QuarterBeat);
Serial.print("\t decimalCount2 = ");
Serial.print(decimalCount);
Serial.print("\t");
Serial.print(decimalCount2);

Serial.println("");
//USING THE stepA0 CONTROL TO LIMIT THE SCAN
   if(scanCol >= stepA0){scanCol = 0; scanRow++;}
    if(scanRow >= stepA0){scanRow = 0;}
//other step
   if(scanCol2 >= OtherStepA1){scanCol2 = 0; scanRow2++;}
    if(scanRow2 >= OtherStepA1){scanRow2 = 0;}

}

}//END LOOP



