// just add more primes to the prime table for larger search
// byte data type to save memory - use a larger datatype with prime table entries above 255 :)
byte primes[]={ 
    2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101,
    102, 107, 109, 113, 127, 131,  137 , 139, 149, 151, 157, 163, 167, 173,  179, 181, 191, 193, 197, 
    199, 211, 223, 227, 229, 233, 239, 241, 251 };

// if you change the datatype of primes array to int, change next line to 
// "const int TopPrimeIndex = (sizeof(primes)/2) - 1;"

const unsigned int TopPrimeIndex = sizeof(primes) - 1;      
const unsigned long TopPrimeSquared = (long)primes[TopPrimeIndex] * (long)primes[TopPrimeIndex];

#include "LedControl.h"

 //  MAX72XX (DIN,CLK,CS)

LedControl lc=LedControl(4,2,3,1);

/* we always wait a bit between updates of the display */
int delaytime=0;
long previousMillis = millis();
long looplength = 10000000;
int interval = 2000;
int stopclock = 0;
int primeFlag;
long randNUmMAX = 300; //limits of prime selected randomly



void setup() {
  /*
   The MAX72XX is in power-saving mode on startup,
   we have to do a wakeup call
   */
    Serial.begin(9600);
  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,8);
  /* and clear the display */
  lc.clearDisplay(0);
}



void primesSel3(long startNum){
  
   for (long x = startNum; x < TopPrimeSquared; x+=2){  // skips even numbers, including 2, which is prime, but it makes algorithm tad faster

            for (long j= 0; j < TopPrimeIndex; j++){
            primeFlag = true;

            if (x == primes[j]) break;

            if (x % primes[j] == 0){     // if the test number modolo (next number from prime table) == 0 
                primeFlag = false;       //  then test number is not prime, bailout and check the next number
                break;
            }
        }
        if (primeFlag == true){           // found a prime - print it
            Serial.println(x);
              stopclock = 1;
          
       }
    }
}

void primesSel4(long startNum){
  long x =startNum; 
 // for (long x = startNum; x < TopPrimeSquared; x+=2){// skips even numbers, including 2, which is prime, but it makes algorithm tad faster

  while(x < TopPrimeSquared){
            for (long j= 0; j < TopPrimeIndex; j++){
            primeFlag = true;

            if (x == primes[j]) break;

            if (x % primes[j] == 0){     // if the test number modolo (next number from prime table) == 0 
                primeFlag = false; 
                 Serial.println(x);//  then test number is not prime, bailout and check the next number
             break;
              
            }
           
        } 
        if (primeFlag == true){// found a prime - print it
          
            stopclock = 0;
            Serial.print("OOOOOOOOO");
            Serial.println(x);
            long i = x;
            //stop the search
            x = TopPrimeSquared;


            //sound test
            tone(5, i);
                int di1 = i / 1%10;
          lc.setDigit(0,0,(di1),false);
          int di10 = i / 10%10;
          lc.setDigit(0,1,(di10),false);
          int di100 = i / 100%10;
          lc.setDigit(0,2,(di100),false);
          int di1000 = i / 1000%10;
          lc.setDigit(0,3,(di1000),false);
              int di10000 = i / 10000%10;
          lc.setDigit(0,4,(di10000),false);
              int di100000 = i / 100000%10;
          lc.setDigit(0,5,(di100000),false);
              int di1000000 = i / 1000000%10;
          lc.setDigit(0,6,(di1000000),false);
              int di10000000 = i / 10000000%10;
          lc.setDigit(0,7,(di10000000),false);
          
       }  x++;
       
         
    }

}



void loop()                     // run over and over again
{


     // STOP THE CLOCK
     if ((millis() - previousMillis > interval) and stopclock ==0) {
        // STOP CLOCK DISPLAY
        long i= random(2,randNUmMAX);
     stopclock = 1;
      previousMillis = millis();
        Serial.println("now");
       primesSel4(i);
   }
}
