// Example 4 - Receive a number as text and convert it to an int

const byte numChars = 32;
char receivedChars[numChars];   // an array to store the received data

boolean newData = false;

int dataNumber = 0; 

#include <MozziGuts.h>
#include <Oscil.h> // oscillator template
#include <tables/sin2048_int8.h> // sine table for oscillator

// use: Oscil <table_size, update_rate> oscilName (wavetable), look in .h file of table #included above
Oscil <SIN2048_NUM_CELLS, AUDIO_RATE> aSin(SIN2048_DATA);
int frequencySine = 22; //actual sine fre
// use #define for CONTROL_RATE, not a constant
#define CONTROL_RATE 64 // powers of 2 please
///IMPORTANT CONTROLS TO CHANGE
   //out of tuneness - adds numbers to frequency
    int toneTwist = random(0,13);

void setup(){
  startMozzi(CONTROL_RATE); // set a control rate of 64 (powers of 2 please)
  aSin.setFreq(440); // set the frequency
    Serial.begin(9600);
    Serial.println("<Arduino is ready>");
}


void updateControl(){
  // put changing controls in here
  aSin.setFreq(frequencySine); // set the frequency
}


int updateAudio(){
  return aSin.next(); // return an int signal centred around 0
}


void loop(){
  audioHook(); // required here
   recvWithEndMarker();
    showNewNumber2();
}
void recvWithEndMarker() {
    static byte ndx = 0;
    char endMarker = '\n';
    char rc;
   
    if (Serial.available() > 0) {
        rc = Serial.read();

        if (rc != endMarker) {
            receivedChars[ndx] = rc;
            ndx++;
            if (ndx >= numChars) {
                ndx = numChars - 1;
            }
        }
        else {
            receivedChars[ndx] = '\0'; // terminate the string
            ndx = 0;
            newData = true;
        }
    }
}

void showNewNumber() {
    if (newData == true) {
        dataNumber = 0;             // new for this version
        dataNumber = atoi(receivedChars);   // new for this version
        //Serial.print("This just in ... ");
        //Serial.println(receivedChars);
       // Serial.print("Data as Number ... ");    // new for this version
        //Serial.println(dataNumber);     // new for this version

        //out of tuneness
toneTwist = random(0, 7);
 //toneTwist = 0;
         
//octaver
int octaver = 3;

if(dataNumber > 777){
dataNumber = (dataNumber) + (toneTwist *9);}

if(dataNumber < 777){
dataNumber = (dataNumber + toneTwist) / octaver;}

if(dataNumber < 400){
dataNumber = (dataNumber + toneTwist);}

if(dataNumber < 140){
dataNumber = (dataNumber + toneTwist) * octaver;}

 Serial.println(dataNumber); 
 frequencySine = dataNumber;
     // tone(5,(dataNumber + toneTwist));
      // pitcher((dataNumber + toneTwist));
      //int tonelen = random(1000, 3500);
     // delay(tonelen);
     // noTone(5);

        
        newData = false;
    }
}

//////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
void showNewNumber2() {
    if (newData == true) {
        dataNumber = 0;             // new for this version
        dataNumber = atoi(receivedChars);   // new for this version
           //out of tuneness
toneTwist = random(0, 9);
        dataNumber = dataNumber / 2 -  toneTwist  ;

 Serial.println(dataNumber); 
 frequencySine = dataNumber;
     newData = false;
    }
}





